{% macro parameter_members(params, call_prefix = "") %}
  // [Parameters]
  std::shared_ptr<rclcpp::ParameterEventHandler> param_subscriber_;
  {% for param in params.list %}
  std::shared_ptr<rclcpp::ParameterCallbackHandle> {{ param.name }}_callback_handle_;
  void {{ param.name }}_param_callback(const rclcpp::Parameter & param) {
    RCLCPP_DEBUG(get_logger(), "Updated param: %s", param.get_name().c_str());
    ins.{{ param.name }} = param.get_value<{{ param.type }}>();
    {%- if param.trigger %}
    {%- if call_prefix == "" %}
    {{ call_prefix }}{{ param.name }}_param_triggered(ins, outs, recv);
    {%- else %}
    {{ call_prefix }}{{ param.name }}_param_triggered(ins, outs);
    {%- endif %}
    {%- endif %}
  }
  {% endfor %}

  {% if params.validation is defined and params.validation %}
  // global callback validation of parameters
  rcl_interfaces::msg::SetParametersResult callback_on_parameters_change(const std::vector<rclcpp::Parameter> & parameters) {
    rcl_interfaces::msg::SetParametersResult result;
    result.successful = {{ call_prefix }}on_validation_parameters(parameters, result);
    return result;
  }
  OnSetParametersCallbackHandle::SharedPtr global_param_cb_handle;
{% endif %}
{% endmacro %}

